SystemOrganization addCategory: #'LRSTM-Compiler'!
SystemOrganization addCategory: #'LRSTM-Errors'!
SystemOrganization addCategory: #'LRSTM-Model'!
SystemOrganization addCategory: #'LRSTM-Tests'!

!RBMethodNode methodsFor: '*LRSTM' stamp: 'lr 5/6/2007 15:30'!
beAtomic
	self propertyAt: #atomic put: true! !

!RBMethodNode methodsFor: '*LRSTM' stamp: 'lr 5/5/2007 19:39'!
isAtomic
	^ self propertyAt: #atomic ifAbsentPut: [ false ]! !

!RBMethodNode methodsFor: '*LRSTM' stamp: 'StefanMarr 12/1/2011 14:19'!
primitive
	self halt.
	self flag: 'STEFAN: this is only filed in from the original LRSTM code. But it seems it would need an adaptation to get the primitive code'.
	"^ primitiveNode ifNotNil: [ :node | node num ]"! !

!LiteralNode methodsFor: '*LRSTM-accessing' stamp: 'StefanMarr 12/1/2011 18:59'!
index
	^ index! !

!OCGlobalVar methodsFor: '*LRSTM-accessing' stamp: 'StefanMarr 12/3/2011 20:03'!
assoc
	^ assoc! !

!ContextPart methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 12:11'!
canHandleSignal: exception
	"Sent to handler (on:do:) contexts only.  If my exception class (first arg) handles exception then return true, otherwise forward this message to the next handler context.  If none left, return false (see nil>>canHandleSignal:)"

	<atomicDoNotTransform>
	^ (((self tempAt: 1) handles: exception) and: [self tempAt: 3])
		or: [self nextHandlerContext canHandleSignal: exception].
! !

!ContextPart methodsFor: '*LRSTM-override' stamp: 'StefanMarr 11/28/2011 23:04'!
handleSignal: exception
	"Sent to handler (on:do:) contexts only.  If my exception class (first arg) handles exception then execute my handle block (second arg), otherwise forward this message to the next handler context.  If none left, execute exception's defaultAction (see nil>>handleSignal:)."

	<atomicDoNotTransform>
	| val |
	(((self tempAt: 1) handles: exception) and: [self tempAt: 3]) ifFalse: [
		^ self nextHandlerContext handleSignal: exception].

	exception privHandlerContext: self contextTag.
	self tempAt: 3 put: false.  "disable self while executing handle block"
	val := [(self tempAt: 2) cull: exception]
		ensure: [self tempAt: 3 put: true].
	self return: val.  "return from self if not otherwise directed in handle block"
! !

!ContextPart methodsFor: '*LRSTM' stamp: 'lr 5/31/2007 15:49'!
workingCopy
	^ self! !

!String methodsFor: '*LRSTM' stamp: 'StefanMarr 12/1/2011 21:37'!
asAtomicSelector
	self isAtomicSelector ifTrue: [^self].

	^ Symbol intern: self atomicPrefix , self! !

!String methodsFor: '*LRSTM' stamp: 'StefanMarr 12/1/2011 21:41'!
asNormalSelector
	self isAtomicSelector ifFalse: [^self].
	
	^ Symbol intern: (self allButFirst: self atomicPrefix size)! !

!String methodsFor: '*LRSTM' stamp: 'lr 4/16/2007 09:48'!
atomicPrefix
	^ '__atomic__'! !

!String methodsFor: '*LRSTM' stamp: 'lr 4/16/2007 09:48'!
isAtomicSelector
	^ self beginsWith: self atomicPrefix! !

!String methodsFor: '*LRSTM-override' stamp: 'StefanMarr 11/28/2011 20:53'!
numArgs 
	"Answer either the number of arguments that the receiver would take if considered a selector.  Answer -1 if it couldn't be a selector. It is intended mostly for the assistance of spelling correction."

	| firstChar numColons start ix |
	self size = 0 ifTrue: [^ -1].
	self isAtomicSelector 
		ifTrue: [ ^ self asNormalSelector numArgs ].
	firstChar := self at: 1.
	(firstChar isLetter or: [ firstChar = $_]) ifTrue:
		["Fast reject if any chars are non-alphanumeric
		NOTE: fast only for Byte things - Broken for Wide"
		self class isBytes
			ifTrue: [(self findSubstring: '~' in: self startingAt: 1 matchTable: Tokenish) > 0 ifTrue: [^ -1]]
			ifFalse: [2 to: self size do: [:i | (self at: i) tokenish ifFalse: [^ -1]]].
		"Fast colon count"
		numColons := 0.  start := 1.
		[(ix := self indexOf: $: startingAt: start) > 0]
			whileTrue:
				[ix = start ifTrue: [^-1].
				numColons := numColons + 1.
				start := ix + 1].
		numColons = 0 ifTrue: [^ 0].
		self last = $:
			ifTrue: [^ numColons]
			ifFalse: [^ -1]].
	firstChar isSpecial ifTrue:
		[self size = 1 ifTrue: [^ 1].
		2 to: self size do: [:i | (self at: i) isSpecial ifFalse: [^ -1]].
		^ 1].
	^ -1.! !

!String methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 15:15'!
replaceFrom: start to: stop with: replacement startingAt: repStart
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	
	<primitive: 105>
	<atomic: #atomicReplaceFrom:to:with:startingAt:>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!MethodNode methodsFor: '*LRSTM' stamp: 'StefanMarr 11/29/2011 00:20'!
beAtomic
	encoder beAtomic! !

!MethodNode methodsFor: '*LRSTM-accessing' stamp: 'StefanMarr 11/30/2011 15:20'!
temporaries: aSequence
	"For transformations etc, not used in compilation"
	temporaries := aSequence asOrderedCollection! !

!Message methodsFor: '*LRSTM' stamp: 'lr 5/14/2007 13:16'!
receiverClassFor: anObject! !

!MessageNode methodsFor: '*LRSTM-testing' stamp: 'StefanMarr 11/30/2011 20:00'!
isAtomicSendToBlock
	^ receiver notNil and:[ receiver isBlockNode and: [selector key = #atomic]]! !

RBProgramNodeVisitor subclass: #LRSTMTransformer
	instanceVariableNames: 'doFullTransformation doLocalTransformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Compiler'!

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:06'!
acceptAssignmentNode: anAssignmentNode
	super acceptAssignmentNode: anAssignmentNode.
	
	self doTransformation ifFalse: [^self].
	
	(anAssignmentNode variable isInstance or:
	[anAssignmentNode variable isGlobal   "or: REMOTE NOT YET SUPPORTED
	[anAssignmentNode variable isRemote]"]) ifTrue: [
		| replacement |
		replacement := self createAtomicAssignment: anAssignmentNode.
		anAssignmentNode parent replaceNode: anAssignmentNode withNode: replacement.
	]! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:06'!
acceptMessageNode: aMessageNode
	| doLocalTransformationOld |
	doLocalTransformationOld := doLocalTransformation.
	
	doLocalTransformation := doLocalTransformation or: [aMessageNode selector = #atomic].

	(self doTransformation and: [aMessageNode isInlined not])
		ifTrue:  [self  transformMessageNode: aMessageNode.]
		ifFalse: [super acceptMessageNode:    aMessageNode.].
	
	doLocalTransformation := doLocalTransformationOld.! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:55'!
acceptMethodNode: aMethodNode
	super acceptMethodNode: aMethodNode.
	doFullTransformation ifTrue: [
		aMethodNode selector: (aMethodNode selector asAtomicSelector)
	].! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:07'!
acceptVariableNode: aVariableNode
	| replacement |
	self doTransformation ifFalse: [^self].
	
	"Not every variable node we are going to encounter is a read.
	 Make sure it is not the variable node of a parent assignment node.
	 Furthermore, we do not need to take care of temp assignments.
	 Only globals, instances, and perhaps remote onces of a closure."
	(aVariableNode isRead
	 and: [aVariableNode isGlobal   or: 
		   [aVariableNode isInstance "or: REMOTES NOT SUPPORTED at the moment
			[aVariableNode isRemote]"]])
		ifFalse: [^self].
	
	"Now we are sure that we have to transform a variable read".
	replacement := self createAtomicReadNode: aVariableNode.
	aVariableNode parent replaceNode: aVariableNode withNode: replacement. 
! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:07'!
applySTMTransformations: methodNode
	"We have two cases:
	  Either it is a normal method, and we do only the atomic blocks,
	  or it is a fully atomic method and we transform everything.
	
		doFullTransformation indicates that we do not only local adaptations.
	"
	
	methodNode acceptVisitor: self.! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 20:11'!
createAtomicAssignment: anAssignmentNode
	| var |
	var := anAssignmentNode variable.
	var isInstance ifTrue: [
		| selfRef instIdx sendArgs |
		selfRef := RBVariableNode named: 'self'.
		selfRef binding: (var binding scope lookupVar: 'self').
		
		instIdx := RBLiteralValueNode value: (var binding index).
		
		sendArgs := OrderedCollection new: 2.
		sendArgs add: instIdx.
		sendArgs add: anAssignmentNode value.
		^ RBMessageNode receiver: selfRef selector: #atomicInstVarAt:put: arguments: sendArgs.
	]
	ifFalse: [
		| globalAssoc sendArgs |
		var isGlobal ifFalse: [self halt: 'I guess we still need to implement something, e.g., remote vars.'].
		
		globalAssoc := RBLiteralValueNode value: var binding assoc.
		
		sendArgs := OrderedCollection new: 1.
		sendArgs add: anAssignmentNode value.
		^ RBMessageNode receiver: globalAssoc selector: #atomicValue: arguments: sendArgs.
	].! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 20:09'!
createAtomicReadNode: aVariableNode
	| selfRef instIdx sendArgs |
	
	aVariableNode isInstance ifTrue: [
		selfRef := RBVariableNode named: 'self'.
		selfRef binding: (aVariableNode binding scope lookupVar: 'self').
		
		instIdx := RBLiteralValueNode value: (aVariableNode binding index).
		sendArgs:= OrderedCollection new: 1.
		sendArgs add: instIdx.
		^ RBMessageNode receiver: selfRef selector: #atomicInstVarAt: arguments: sendArgs.	
	]
	ifFalse: [
		| globalAssoc |
		aVariableNode isGlobal ifFalse: [self halt: 'I guess we still need to implement something, e.g., remote vars.'].
		
		globalAssoc := RBLiteralValueNode value: aVariableNode binding assoc.
		^ RBMessageNode receiver: globalAssoc selector: #atomicValue.
	].
	! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:08'!
doTransformation
	^ doFullTransformation or: [doLocalTransformation]! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:56'!
fullTransformation: aBool
	doFullTransformation := aBool! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:08'!
initialize
	doFullTransformation  := false.
	doLocalTransformation := false.
! !

!LRSTMTransformer methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:07'!
transformMessageNode: aMessageNode

	| selector |
	selector := aMessageNode selector.
	(selector = #atomic or: [aMessageNode isInlined]) ifFalse: [
		aMessageNode selector: selector asAtomicSelector.
	].
	
	super acceptMessageNode: aMessageNode.! !

!VariableNode methodsFor: '*LRSTM-testing' stamp: 'StefanMarr 11/30/2011 15:04'!
isAtomicTemp
	^ false! !

!WriteStream methodsFor: '*LRSTM' stamp: 'lr 6/7/2007 15:17'!
atomicNextPut: anObject 
	((collection class == ByteString) 
		and: [ anObject isCharacter 
		and: [ anObject isOctetCharacter not ] ]) ifTrue: [
			collection := WideString from: collection.
			^ self nextPut: anObject ].
	^ position >= writeLimit
		ifTrue: [ self pastEndPut: anObject ]
		ifFalse: [ collection at: (position := position + 1) put: anObject ]! !

!WriteStream methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 15:20'!
nextPut: anObject
	"Primitive. Insert the argument at the next position in the Stream
	represented by the receiver. Fail if the collection of this stream is not an
	Array or a String. Fail if the stream is positioned at its end, or if the
	position is out of bounds in the collection. Fail if the argument is not
	of the right type for the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 66>
	<atomic: #atomicNextPut:>
	((collection class == ByteString) and: [
		anObject isCharacter and:[anObject isOctetCharacter not]]) ifTrue: [
			collection := (WideString from: collection).
			^self nextPut: anObject.
	].
	position >= writeLimit
		ifTrue: [^ self pastEndPut: anObject]
		ifFalse: 
			[position := position + 1.
			^collection at: position put: anObject]! !

!CompiledMethod methodsFor: '*LRSTM' stamp: 'lr 5/9/2007 10:37'!
atomicMethod
	^ LRSTMCompiler atomicMethodFor: self! !

!Symbol methodsFor: '*LRSTM-override' stamp: 'lr 5/10/2007 12:01'!
precedence
	"Answer the receiver's precedence, assuming it is a valid Smalltalk
	message selector or 0 otherwise.  The numbers are 1 for unary,
	2 for binary and 3 for keyword selectors."

	self isAtomicSelector 
		ifTrue: [ ^ self asNormalSelector precedence ].
	self size = 0 ifTrue: [^ 0].
	self first isLetter ifFalse: [^ 2].
	self last = $: ifTrue: [^ 3].
	^ 1! !

!Process methodsFor: '*LRSTM' stamp: 'lr 5/30/2007 12:09'!
currentTransaction
	^ currentTransaction! !

!Process methodsFor: '*LRSTM' stamp: 'lr 5/30/2007 12:09'!
currentTransaction: aTransaction
	currentTransaction := aTransaction! !

!RBMessageNode class methodsFor: '*LRSTM' stamp: 'lr 5/10/2007 11:43'!
receiver: aValueNode atomicSelector: aSymbol arguments: anotherValueNodes
	^ self new
		receiver: aValueNode;
		arguments: anotherValueNodes;
		atomicSelector: aSymbol;
		yourself! !

!RBMessageNode methodsFor: '*LRSTM' stamp: 'lr 5/9/2007 14:50'!
atomicSelector: aSelector
	| keywords numArgs |
	aSelector isAtomicSelector 
		ifTrue: [ self error: 'Normal selector expected: ' , aSelector ].
	selector := aSelector asAtomicSelector.
	keywords := aSelector keywords.
	numArgs := selector last = $:
		ifTrue: [ keywords size ]
		ifFalse: [ 0 ].
	selectorParts := numArgs = 0
		ifTrue: [ Array with: (RBIdentifierToken value: selector start: nil) ]
		ifFalse: [ keywords collect: [ :each | RBKeywordToken value: each start: nil ] ]! !

!RBMessageNode methodsFor: '*LRSTM' stamp: 'StefanMarr 12/3/2011 14:22'!
isInlined
	^ self isInlineAndOr or:
	 [self isInlineCase  or:
	 [self isInlineIf    or:
	 [self isInlineIfNil or:
	 [self isInlineToDo  or:
	  self isInlineWhile    ]]]]! !

!MethodContext methodsFor: '*LRSTM-override' stamp: 'StefanMarr 11/28/2011 23:07'!
tempAt: index 
	"Answer the value of the temporary variable whose index is the 
	 argument, index.  Primitive. Assumes receiver is indexable. Answer the
	 value of an indexable element in the receiver. Fail if the argument index
	 is not an Integer or is out of bounds. Essential. See Object documentation
	 whatIsAPrimitive.  Override the default at: primitive to give latitude to the
	 VM in context management."
	
	<atomicDoNotTransform>
	<primitive: 210>
	^self at: index! !

!MethodContext methodsFor: '*LRSTM-override' stamp: 'StefanMarr 11/28/2011 23:07'!
tempAt: index put: value 
	"Store the argument, value, as the temporary variable whose index is the 
	 argument, index.  Primitive. Assumes receiver is indexable. Answer the
	 value of an indexable element in the receiver. Fail if the argument index
	 is not an Integer or is out of bounds. Essential. See Object documentation
	 whatIsAPrimitive.  Override the default at:put: primitive to give latitude to
	 the VM in context management."

	<atomicDoNotTransform>
	<primitive: 211>
	^self at: index put: value! !

!Behavior methodsFor: '*LRSTM' stamp: 'lr 5/9/2007 13:19'!
atomicMethods
	^ Array streamContents: [ :stream |
		self methodDictionary keysAndValuesDo: [ :key :value |
			key isAtomicSelector 
				ifTrue: [ stream nextPut: value ] ] ]! !

!Behavior methodsFor: '*LRSTM-override' stamp: 'StefanMarr 11/29/2011 17:52'!
basicNew
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	indexable variables. Fail if the class is indexable. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 70>
	<atomicDoNotTransform>
	self isVariable ifTrue: [ ^ self basicNew: 0 ].
	"space must be low"
	OutOfMemory signal.
	^ self basicNew  "retry if user proceeds"! !

!Behavior methodsFor: '*LRSTM-override' stamp: 'StefanMarr 11/29/2011 17:50'!
basicNew: sizeRequested 
	"Primitive. Answer an instance of this class with the number
	of indexable variables specified by the argument, sizeRequested.
	Fail if this class is not indexable or if the argument is not a
	positive Integer, or if there is not enough memory available. 
	Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	<atomicDoNotTransform>
	self isVariable ifFalse:
		[self error: self printString, ' cannot have variable sized instances'].
	(sizeRequested isInteger and: [sizeRequested >= 0]) ifTrue:
		["arg okay; space must be low."
		OutOfMemory signal.
		^ self basicNew: sizeRequested  "retry if user proceeds"].
	self primitiveFailed! !

!Behavior methodsFor: '*LRSTM-override' stamp: 'StefanMarr 12/1/2011 16:39'!
compilerClass
	"Answer a compiler class appropriate for source methods of this class."
	
	(Smalltalk hasClassNamed: #LRSTMCompiler) ifTrue: [
		| compiler |
		compiler := Smalltalk at: #LRSTMCompiler.
		compiler useLRSTMCompilerOnce ifTrue: [^ compiler ]
	].

	^Compiler! !

!Behavior methodsFor: '*LRSTM' stamp: 'lr 5/11/2007 16:01'!
flushAtomic
	| copy |
	self methodDictionary keysDo: [ :each |
		each isAtomicSelector ifTrue: [
			copy := copy ifNil: [ self methodDictionary copy ].
			copy removeDangerouslyKey: each ifAbsent: [] ] ].
	copy ifNotNil: [ self methodDictionary become: copy ]! !

!Behavior methodsFor: '*LRSTM-override' stamp: 'lr 5/9/2007 11:05'!
selectors
	"Answer a Set of all the message selectors specified in the receiver's 
	method dictionary."

	^ self methodDict keys reject: [ :each | each isAtomicSelector ]! !

!Behavior methodsFor: '*LRSTM-override' stamp: 'lr 5/9/2007 11:05'!
selectorsAndMethodsDo: aBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysAndValuesDo: [ :selector :method |
		selector isAtomicSelector 
			ifFalse: [ aBlock value: selector value: method ] ]! !

!Behavior methodsFor: '*LRSTM-override' stamp: 'lr 5/9/2007 11:06'!
selectorsDo: selectorBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysDo: [ :selector |
		selector isAtomicSelector 
			ifFalse: [ selectorBlock value: selector ] ]! !

!EncoderForLongFormV3PlusClosures methodsFor: '*LRSTM' stamp: 'StefanMarr 11/29/2011 14:42'!
atomic
	^ false! !

!EncoderForLongFormV3PlusClosures methodsFor: '*LRSTM' stamp: 'StefanMarr 11/29/2011 14:42'!
atomic: aBool
	^ false! !

!RBVariableNode methodsFor: '*LRSTM-opalcompiler-core' stamp: 'StefanMarr 12/3/2011 12:25'!
isRemote
	^self binding isRemote! !

!TPureBehavior methodsFor: '*LRSTM' stamp: 'lr 5/9/2007 13:19'!
atomicMethods
	^ Array streamContents: [ :stream |
		self methodDictionary keysAndValuesDo: [ :key :value |
			key isAtomicSelector 
				ifTrue: [ stream nextPut: value ] ] ]! !

!TPureBehavior methodsFor: '*LRSTM' stamp: 'lr 5/11/2007 16:01'!
flushAtomic
	| copy |
	self methodDictionary keysDo: [ :each |
		each isAtomicSelector ifTrue: [
			copy := copy ifNil: [ self methodDictionary copy ].
			copy removeDangerouslyKey: each ifAbsent: [] ] ].
	copy ifNotNil: [ self methodDictionary become: copy ]! !

!TPureBehavior methodsFor: '*LRSTM-override' stamp: 'lr 5/9/2007 11:05'!
selectors
	"Answer a Set of all the message selectors specified in the receiver's 
	method dictionary."

	^ self methodDict keys reject: [ :each | each isAtomicSelector ]! !

!TPureBehavior methodsFor: '*LRSTM-override' stamp: 'lr 5/9/2007 11:05'!
selectorsAndMethodsDo: aBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysAndValuesDo: [ :selector :method |
		selector isAtomicSelector 
			ifFalse: [ aBlock value: selector value: method ] ]! !

!TPureBehavior methodsFor: '*LRSTM-override' stamp: 'lr 5/9/2007 11:06'!
selectorsDo: selectorBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysDo: [ :selector |
		selector isAtomicSelector 
			ifFalse: [ selectorBlock value: selector ] ]! !

OCClosureCompiler subclass: #LRSTMCompiler
	instanceVariableNames: 'doFullTransformation'
	classVariableNames: 'Enabled UseCounterForDebugging UseLRSTMCompiler'
	poolDictionaries: ''
	category: 'LRSTM-Compiler'!

!LRSTMCompiler commentStamp: 'StefanMarr 11/28/2011 22:47' prior: 0!
This is just a helper class holding the compilation related methods similar to the original implementation of ACCompiler!

!LRSTMCompiler class methodsFor: 'actions' stamp: 'StefanMarr 11/29/2011 00:05'!
atomicFail: aCompiledMethod
	"Failed to compile aCompiledMethod. Show error in transcript and install the origianl method."
	
	Transcript
		show: 'ERROR: Failed to compile for atomic execution: '; show: aCompiledMethod methodClass; 
		show: '>>#'; show: aCompiledMethod selector; cr.
	^ aCompiledMethod! !

!LRSTMCompiler class methodsFor: 'actions' stamp: 'StefanMarr 11/29/2011 21:28'!
atomicMethod: aMessage missing: aReceiver
	"This method is called whenever a missing atomic method is called. Installs a whole hierarchy of atomic methods."

	| selector |
	selector := aMessage selector asNormalSelector.
	ProtoObject withAllSubclassesDo: [ :class |
		(class methodDictionary includesKey: selector) ifTrue: [
			self installAtomicVersionOf: (class methodDictionary at: selector).] ]! !

!LRSTMCompiler class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/1/2011 21:20'!
disableCompiler
	UseLRSTMCompiler := false.
	UseCounterForDebugging := 0.! !

!LRSTMCompiler class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 20:59'!
enableCompiler
	self enableCompiler: 3.! !

!LRSTMCompiler class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 17:12'!
enableCompiler: forNTimes
	UseLRSTMCompiler := true.
	UseCounterForDebugging := forNTimes.! !

!LRSTMCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 12/3/2011 21:09'!
initialize
	Transcript cr; show: '===INITIALIZE LRSTM [START]===='.
	(Process hasInstVarNamed: 'currentTransaction') ifFalse: [
		Process addInstVarNamed: 'currentTransaction'.
	].
	
	UseLRSTMCompiler := true.
	self recompileTestClassesWithLRSTMCompiler.
	
	SystemChangeNotifier uniqueInstance
		notify: self ofSystemChangesOfItem: #method change: #Added using: #onMethodAdded:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #onMethodAdded:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #onMethodRemoved:.
	
	Transcript cr; show: '===INITIALIZE LRSTM [COMPLETED]===='.
! !

!LRSTMCompiler class methodsFor: 'actions' stamp: 'StefanMarr 12/3/2011 19:29'!
installAtomicVersionOf: aCompiledMethod
	"Answer the atomic counterpart of aCompiledMethod.
	Methods with the pragma #atomic are considered to be already atomic.
	Methods with the pragma #atomic: will use the annotation code for the atomic counterpart.
	#atomicInstead: will use the annotiation code for atomic transformation."

	| atomicCM atomicName |
	"Is already atomic do nothing"
	aCompiledMethod selector isAtomicSelector ifTrue: [
		^ aCompiledMethod ].

	atomicName := aCompiledMethod selector asAtomicSelector.
	
	aCompiledMethod pragmas do: [ :each |
		each keyword = #atomicDoNotTransform
			ifTrue: [ atomicCM := aCompiledMethod.
						aCompiledMethod methodClass methodDict at: atomicName put: atomicCM.
						^ atomicCM ].
		each keyword = #atomic:
			ifTrue: [
				atomicCM := self installAtomicVersionOf: 
								(aCompiledMethod methodClass lookupSelector: each arguments first).
				aCompiledMethod methodClass methodDict at: atomicName put: atomicCM.
				^ atomicCM ].
	].
	
	
	[ | newMethod |
		newMethod := LRSTMCompiler recompileAtomically: aCompiledMethod.
		aCompiledMethod methodClass methodDict at: atomicName put: newMethod.
	  ^ newMethod] value.

		"ifError: [ :err :rcvr |
						Transcript log: 'FAILED to compile ', atomicName, ' error: ' , err asString, ' rcvr: ', rcvr asString. 
						self haltOnce.
						self atomicFail: aCompiledMethod ]."
	^ nil! !

!LRSTMCompiler class methodsFor: 'events' stamp: 'StefanMarr 11/29/2011 21:26'!
onMethodAdded: anObject
	"Ignore the already atomic methods"
	anObject itemSelector isAtomicSelector ifTrue: [
		^self].
	
	"Also blacklist a few things"
	((anObject itemClass = Debugger)
	or: [anObject itemClass = Decompiler])
		ifTrue: [^ self].

	"For the rest we do the atomic stuff"	
	self installAtomicVersionOf: (anObject itemClass methodDict
			at: anObject itemSelector).! !

!LRSTMCompiler class methodsFor: 'events' stamp: 'StefanMarr 11/28/2011 23:52'!
onMethodRemoved: anObject
	anObject itemClass methodDict 
		removeKey: anObject itemSelector 
			asAtomicSelector
		ifAbsent: nil! !

!LRSTMCompiler class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 18:07'!
recompile: aCompiledMethod
	"Recompile the given method normally"

	| compiler |
	compiler := LRSTMCompiler new.
	^ compiler recompile: aCompiledMethod.! !

!LRSTMCompiler class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 18:07'!
recompileAtomically: aCompiledMethod
	"Recompile the given method normally"

	| compiler |
	compiler := LRSTMCompiler new.
	^ compiler recompileAtomically: aCompiledMethod.! !

!LRSTMCompiler class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 20:58'!
recompileTestClassesWithLRSTMCompiler
	self enableCompiler.
	(PackageInfo named: 'LRSTM-Tests') classes do: [:c | c compileAll] displayingProgress: 'Recompiling Tests with LRSTM support enabled'.! !

!LRSTMCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 12/2/2011 11:42'!
unload
	Enabled := false.

	Smalltalk allClassesAndTraits 
		do: [ :ea | ea flushAtomic. ea class flushAtomic ]
		displayingProgress: 'Flushing Atomic Methods'.
	Process removeInstVarNamed: 'currentTransaction'! !

!LRSTMCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 12/2/2011 11:42'!
unregisterChangeListener

	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self.! !

!LRSTMCompiler class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/1/2011 16:00'!
useLRSTMCompiler
	^ UseLRSTMCompiler = true! !

!LRSTMCompiler class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 20:14'!
useLRSTMCompilerOnce
	| result |
	self useLRSTMCompiler ifTrue: [^true].
	
	result := UseCounterForDebugging.
	result ifNil: [
		UseCounterForDebugging := 3.
		result := UseCounterForDebugging.].
	
	UseCounterForDebugging := UseCounterForDebugging - 1.
	^ result > 0! !

!LRSTMCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 18:03'!
compile: textOrStream in: aClass classified: aCategory notifying: aRequestor ifFail: failBlock 
	| methodNode transformer |
	methodNode := super compile: textOrStream in: aClass classified: aCategory notifying: aRequestor ifFail: failBlock.
	
	transformer := LRSTMTransformer new.
	transformer fullTransformation: doFullTransformation.
	transformer applySTMTransformations: methodNode.
	^ methodNode! !

!LRSTMCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 18:02'!
initialize
	super initialize.
	doFullTransformation := false.! !

!LRSTMCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 18:06'!
recompile: aCompiledMethod
	"Recompile the given method normally, i.e., with out full STM transformation"

	^ self recompile: aCompiledMethod atomically: false.! !

!LRSTMCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 19:03'!
recompile: aCompiledMethod atomically: aBool
	"Recompile the given method with the STM enabled"

	| source newSelector  newMethod |
	
	doFullTransformation := aBool.
	
	source := aCompiledMethod getSource.
	newSelector := aCompiledMethod selector asAtomicSelector.
		
	newMethod := self
		compile: source in: aCompiledMethod methodClass notifying: self
		ifFail: [^ self problem: 'syntax error' sel: newSelector in: aCompiledMethod methodClass].

	^ newMethod generate.! !

!LRSTMCompiler methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 18:06'!
recompileAtomically: aCompiledMethod
	"Recompile the given method with the STM enabled"

	^ self recompile: aCompiledMethod atomically: true.! !

!BlockContext methodsFor: '*LRSTM' stamp: 'lr 2/26/2008 18:16'!
atomic
	^ LRSTMTransaction new do: self! !

!BlockContext methodsFor: '*LRSTM' stamp: 'lr 5/25/2007 09:13'!
atomicIfConflict: aBlock
	^ LRSTMTransaction new do: self ifConflict: aBlock! !

!BlockContext methodsFor: '*LRSTM' stamp: 'lr 5/25/2007 09:14'!
atomicRetry
	^ LRSTMTransaction new retry: self! !

!BlockContext methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 12:10'!
tempAt: index 
	"Refer to the comment in ContextPart|tempAt:."

	<atomicDoNotTransform>
	^ home at: index! !

!BlockContext methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 12:11'!
tempAt: index put: value 
	"Refer to the comment in ContextPart|tempAt:put:."

	<atomicDoNotTransform>
	^ home at: index put: value! !

Error subclass: #LRSTMConflict
	instanceVariableNames: 'transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Errors'!

!LRSTMConflict methodsFor: 'accessing' stamp: 'lr 5/25/2007 09:04'!
transaction
	^ transaction! !

!LRSTMConflict methodsFor: 'accessing' stamp: 'lr 5/25/2007 09:04'!
transaction: aTransaction
	transaction := aTransaction! !

Error subclass: #LRSTMInvalidTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Errors'!

!ReadStream methodsFor: '*LRSTM' stamp: 'lr 6/7/2007 15:16'!
atomicNext
	^ position >= readLimit
		ifFalse: [ collection at: (position := position + 1) ]! !

!ReadStream methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 15:16'!
next
	"Primitive. Answer the next object in the Stream represented by the
	receiver. Fail if the collection of this stream is not an Array or a String.
	Fail if the stream is positioned at its end, or if the position is out of
	bounds in the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 65>
	<atomic: #atomicNext>
	position >= readLimit
		ifTrue: [^nil]
		ifFalse: [^collection at: (position := position + 1)]! !

!Integer methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 12:11'!
timesRepeat: aBlock
	"Evaluate the argument, aBlock, the number of times represented by the 
	receiver."

	<atomicDoNotTransform>
	| count |
	count := 1.
	[count <= self]
		whileTrue: 
			[aBlock value.
			count := count + 1]! !

!BlockClosure methodsFor: '*LRSTM' stamp: 'StefanMarr 11/28/2011 20:58'!
atomic
	^ LRSTMTransaction new do: self! !

!BlockClosure methodsFor: '*LRSTM' stamp: 'lr 5/25/2007 09:14'!
atomicIfConflict: aBlock
	^ LRSTMTransaction new do: self ifConflict: aBlock! !

!BlockClosure methodsFor: '*LRSTM' stamp: 'lr 5/25/2007 09:15'!
atomicRetry
	^ LRSTMTransaction new retry: self! !

!Exception methodsFor: '*LRSTM' stamp: 'lr 6/7/2007 12:11'!
resumeUnchecked: resumptionValue
	"Return resumptionValue as the value of #signal, unless this was called after an #outer message, then return resumptionValue as the value of #outer."

	<atomicDoNotTransform>
	| ctxt |
	outerContext ifNil: [
		signalContext return: resumptionValue
	] ifNotNil: [
		ctxt _ outerContext.
		outerContext _ ctxt tempAt: 1. "prevOuterContext in #outer"
		ctxt return: resumptionValue
	].
! !

!Array methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 15:15'!
replaceFrom: start to: stop with: replacement startingAt: repStart
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 105>
	<atomic: #atomicReplaceFrom:to:with:startingAt:>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!LookupKey methodsFor: '*LRSTM' stamp: 'lr 5/25/2007 11:18'!
atomicValue
	^ self workingCopy value! !

!LookupKey methodsFor: '*LRSTM' stamp: 'lr 5/25/2007 11:18'!
atomicValue: anObject
	^ self workingCopy value: anObject! !

!EncoderForV3PlusClosures methodsFor: '*LRSTM' stamp: 'StefanMarr 11/29/2011 15:32'!
atomic
	^ false! !

!EncoderForV3PlusClosures methodsFor: '*LRSTM' stamp: 'StefanMarr 11/29/2011 15:33'!
atomic: aBool
	^ false! !

TestCase subclass: #LRSTMTest
	instanceVariableNames: 'value array'
	classVariableNames: 'Value'
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

LRSTMTest subclass: #LRSTMAbortTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'StefanMarr 11/30/2011 20:12'!
testAbortAccessor
	self assert: [ self value: true; abort: self value ] atomic.
	self assert: self value isNil! !

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'lr 5/14/2007 09:11'!
testAbortInstance
	self assert: [ value := true. self abort: value ] atomic.
	self assert: value isNil! !

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'lr 5/14/2007 09:12'!
testAbortLiteral
	self assert: [ Value := true. self abort: Value ] atomic.
	self assert: Value isNil! !

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'lr 5/14/2007 09:12'!
testAbortTemp
	| temp |
	self assert: [ temp := true. self abort: temp ] atomic.
	self assert: temp! !

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'lr 5/14/2007 09:12'!
testAbortVariable
	self assert: [ array at: 1 put: true. self abort: (array at: 1) ] atomic.
	self assert: (array at: 1) isNil! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 6/8/2007 16:50'!
testCheckAccessor
	self assert: [ self value: true; checkpoint; abort: self value ] atomic.
	self assert: self value! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 5/14/2007 09:13'!
testCheckInstance
	self assert: [ value := true. self checkpoint. self abort: value ] atomic.
	self assert: value! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 5/14/2007 09:13'!
testCheckLiteral
	self assert: [ Value := true. self checkpoint. self abort: Value ] atomic.
	self assert: Value! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 5/14/2007 09:13'!
testCheckTemp
	| temp |
	self assert: [ temp := true. self checkpoint. self abort: temp ] atomic.
	self assert: temp! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 5/14/2007 09:13'!
testCheckVariable
	self assert: [ array at: 1 put: true. self checkpoint. self abort: (array at: 1) ] atomic.
	self assert: (array at: 1)! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'lr 5/14/2007 08:39'!
testErrorAccessor
	self 
		should: [ [ self value: true. self assert: self value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: (array at: 1) isNil! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'lr 5/14/2007 08:39'!
testErrorInstance
	self 
		should: [ [ value := true. self assert: value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: value isNil! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'lr 5/14/2007 08:39'!
testErrorLiteral
	self 
		should: [ [ Value := true. self assert: Value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: Value isNil! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'lr 5/14/2007 08:43'!
testErrorTemp
	| temp |
	self 
		should: [ [ temp := true. self assert: temp. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: temp! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'lr 5/14/2007 08:39'!
testErrorVariable
	self 
		should: [ [ array at: 1 put: true. self assert: (array at: 1). 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: (array at: 1) isNil! !

LRSTMTest subclass: #LRSTMBasicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:18'!
testAccessor
	self assert: [ self value: true. self value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:18'!
testAccessorRead
	self value: true.
	self assert: [ self value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:18'!
testAccessorWrite
	[ self value: true ] atomic.
	self assert: self value! !

!LRSTMBasicTest methodsFor: 'testing-basic' stamp: 'lr 5/9/2007 14:56'!
testBasicContext
	self assert: [ thisContext home ] atomic == thisContext! !

!LRSTMBasicTest methodsFor: 'testing-basic' stamp: 'lr 5/9/2007 11:18'!
testBasicSelf
	self assert: [ self ] atomic == self! !

!LRSTMBasicTest methodsFor: 'testing-basic' stamp: 'lr 5/9/2007 11:18'!
testBasicSuper
	self assert: [ super ] atomic == self! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testGlobal
	self assert: [ GlobalValue := true. GlobalValue ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testGlobalRead
	GlobalValue := true.
	self assert: [ GlobalValue ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testGlobalWrite
	[ GlobalValue := true ] atomic.
	self assert: GlobalValue! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 14:58'!
testInlinedAndOr
	self assert: [ true and: [ true ] ] atomic.
	self deny: [ false and: [ true ] ] atomic.
	self deny: [ true and: [ false ] ] atomic.
	self deny: [ false and: [ false ] ] atomic.

	self assert: [ true or: [ true ] ] atomic.
	self assert: [ false or: [ true ] ] atomic.
	self assert: [ true or: [ false ] ] atomic.
	self deny: [ false and: [ false ] ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/11/2007 15:07'!
testInlinedArray
	self assert: [ { } ] atomic = #( ).
	self assert: [ { 1 } ] atomic = #( 1 ).
	self assert: [ { 1. 2 } ] atomic = #( 1 2 ).
	self assert: [ { 1. 2. 3 } ] atomic = #( 1 2 3 ).
	self assert: [ { 1. 2. 3. 4 } ] atomic = #( 1 2 3 4 ).
	self assert: [ { 1. 2. 3. 4. 5 } ] atomic = #( 1 2 3 4 5 ).
	self assert: [ { 1. 2. 3. 4. 5. 6 } ] atomic = #( 1 2 3 4 5 6 )! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/11/2007 15:23'!
testInlinedArrayNested
	self assert: [ { { } } ] atomic = #( ( ) ).
	self assert: [ { { 1 } } ] atomic = #( ( 1 ) ).
	self assert: [ { { 1. 2 } } ] atomic = #( ( 1 2 ) ).
	self assert: [ { { 1. 2 }. { 3 } } ] atomic = #( ( 1 2 ) ( 3 ) ).
	self assert: [ { { 1. 2 }. { 3. 4 } } ] atomic = #( ( 1 2 ) ( 3 4 ) )! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 14:58'!
testInlinedIfNil
	self assert: [ nil ifNil: [ true ] ] atomic.
	self assert: [ 1 ifNotNil: [ true ] ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 14:58'!
testInlinedIfTrue
	self assert: [ true ifTrue: [ true ] ] atomic.
	self assert: [ false ifFalse: [ true ] ] atomic.
	self assert: [ true ifTrue: [ true ] ifFalse: [ false ] ] atomic.
	self assert: [ false ifFalse: [ true ] ifTrue: [ false ] ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 11:42'!
testInlinedToDo
	| x |
	x := 0.
	[ 1 to: 10 do: [ :i | x := x + i ] ] atomic.
	self assert: x = 55.
	
	x := 0.
	[ 1 to: 10 by: 2 do: [ :i | x := x + i ] ] atomic.
	self assert: x = 25 ! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 15:14'!
testInlinedWhile
	| i x | 
	i := 1. x := 0.
	[ [ x := x + i. i := i + 1. i <= 10 ] whileTrue ] atomic.
	self assert: x = 55.
	
	i := 1. x := 0.
	[ [ i <= 10 ] whileTrue: [ x := x + i. i := i + 1 ] ] atomic.
	self assert: x = 55.
	
	i := 1. x := 0.
	[ [ x := x + i. i := i + 1. i > 10 ] whileFalse ] atomic.
	self assert: x = 55.
	
	i := 1. x := 0.
	[ [ i > 10 ] whileFalse: [ x := x + i. i := i + 1 ] ] atomic.
	self assert: x = 55! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testInstance
	self assert: [ value := true. value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testInstanceRead
	value := true.
	self assert: [ value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testInstanceWrite
	[ value := true ] atomic.
	self assert: value! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testLiteral
	self assert: [ Value := true. Value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testLiteralRead
	Value := true.
	self assert: [ Value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testLiteralWrite
	[ Value := true ] atomic.
	self assert: Value! !

!LRSTMBasicTest methodsFor: 'testing' stamp: 'lr 5/10/2007 09:48'!
testLoop
	"This code showed some bug in the exception handling."
	
 	| current |
	[ current := SortedCollection.
	[ current == nil ] whileFalse: [
		current == Object ifTrue: [ ^ self ].
		current := current superclass ] ]
			value.
	self assert: current == Object! !

!LRSTMBasicTest methodsFor: 'testing-sends' stamp: 'lr 5/9/2007 11:24'!
testSendBinary
	self assert: [ 1 + 2 ] atomic = 3! !

!LRSTMBasicTest methodsFor: 'testing-sends' stamp: 'lr 5/9/2007 11:24'!
testSendKeyword
	self assert: [ 2 raisedTo: 3 ] atomic = 8! !

!LRSTMBasicTest methodsFor: 'testing-sends' stamp: 'lr 5/9/2007 11:24'!
testSendUnary
	self assert: [ 1 negated ] atomic = -1! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testTemp
	| temp |
	self assert: [ temp := true. temp ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testTempRead
	| temp |
	temp := true.
	self assert: [ temp ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testTempWrite
	| temp |
	[ temp := true ] atomic.
	self assert: temp! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testVariable
	self assert: [ array at: 1 put: true; at: 1 ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testVariableRead
	array at: 1 put: true.
	self assert: [ array at: 1 ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testVariableWrite
	[ array at: 1 put: true ] atomic.
	self assert: (array at: 1)! !

LRSTMTest subclass: #LRSTMCUTransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMCUTransactionTest commentStamp: 'StefanMarr 11/28/2011 22:08' prior: 0!
This test suite is actually originating from the Cutie-Helvetia-Trans implementation.
It is ported back to the STM implementation Lukas Renggli implemented originally with Geppetto on Squeak 3.9!

!LRSTMCUTransactionTest methodsFor: 'private' stamp: 'lr 2/23/2009 15:55'!
atomicInstVarAt: anInteger
	^ self workingCopy instVarAt: anInteger! !

!LRSTMCUTransactionTest methodsFor: 'private' stamp: 'lr 2/23/2009 15:55'!
atomicInstVarAt: anInteger put: anObject
	^ self workingCopy instVarAt: anInteger put: anObject! !

!LRSTMCUTransactionTest methodsFor: 'testing-custom' stamp: 'StefanMarr 11/28/2011 22:25'!
conflict
	self transaction 
		addChange: (LRSTMCustomChange 
			onApply: [ value := true ]
			onConflictTest: [ true ])! !

!LRSTMCUTransactionTest methodsFor: 'testing-custom' stamp: 'StefanMarr 11/28/2011 22:21'!
sideeffect
	self transaction 
		addChange: (LRSTMCustomChange
			onApply: [ value := true ])! !

!LRSTMCUTransactionTest methodsFor: 'testing-abort' stamp: 'lr 2/23/2009 16:31'!
testAbortAccessor
	self assert: [ self value: true; abort: self value ] atomic.
	self assert: self value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-abort' stamp: 'lr 2/23/2009 16:31'!
testAbortInstance
	self assert: [ value := true. self abort: value ] atomic.
	self assert: value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-abort' stamp: 'lr 2/23/2009 16:31'!
testAbortTemp
	| temp |
	self assert: [ temp := true. self abort: temp ] atomic.
	self assert: temp! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testAccessor
	self assert: [ self value: true. self value ] atomic! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testAccessorRead
	self value: true.
	self assert: [ self value ] atomic! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testAccessorWrite
	[ self value: true ] atomic.
	self assert: self value! !

!LRSTMCUTransactionTest methodsFor: 'testing' stamp: 'lr 2/23/2009 16:31'!
testBasicContext
	self assert: [ thisContext home ] atomic == thisContext! !

!LRSTMCUTransactionTest methodsFor: 'testing' stamp: 'lr 2/23/2009 16:31'!
testBasicSelf
	self assert: [ self ] atomic == self! !

!LRSTMCUTransactionTest methodsFor: 'testing' stamp: 'lr 2/23/2009 16:31'!
testBasicSuper
	self assert: [ super ] atomic == self! !

!LRSTMCUTransactionTest methodsFor: 'testing-check' stamp: 'lr 2/23/2009 16:31'!
testCheckAccessor
	self assert: [ self value: true; checkpoint; abort: self value ] atomic.
	self assert: self value! !

!LRSTMCUTransactionTest methodsFor: 'testing-check' stamp: 'lr 2/23/2009 16:31'!
testCheckInstance
	self assert: [ value := true. self checkpoint. self abort: value ] atomic.
	self assert: value! !

!LRSTMCUTransactionTest methodsFor: 'testing-check' stamp: 'lr 2/23/2009 16:31'!
testCheckTemp
	| temp |
	self assert: [ temp := true. self checkpoint. self abort: temp ] atomic.
	self assert: temp! !

!LRSTMCUTransactionTest methodsFor: 'testing-custom' stamp: 'StefanMarr 11/28/2011 22:25'!
testConflict
	self 
		should: [ [ self conflict ] atomic ]
		raise: LRSTMConflict.
	self assert: value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-error' stamp: 'lr 2/23/2009 16:31'!
testErrorAccessor
	self 
		should: [ [ self value: true. self assert: self value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-error' stamp: 'lr 2/23/2009 16:31'!
testErrorInstance
	self 
		should: [ [ value := true. self assert: value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-error' stamp: 'lr 2/23/2009 16:31'!
testErrorTemp
	| temp |
	self 
		should: [ [ temp := true. self assert: temp. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: temp! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testInstance
	self assert: [ value := true. value ] atomic! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testInstanceRead
	value := true.
	self assert: [ value ] atomic! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testInstanceWrite
	[ value := true ] atomic.
	self assert: value! !

!LRSTMCUTransactionTest methodsFor: 'testing-custom' stamp: 'lr 2/23/2009 16:31'!
testSideeffect
	[ self sideeffect ] atomic.
	self assert: value! !

!LRSTMCUTransactionTest methodsFor: 'private' stamp: 'lr 2/23/2009 16:43'!
workingCopy
	"Answer a working copy to be used within the context of the current transaction."
	
	| transaction |
	transaction := self transaction
		ifNil: [ ^ self ].
	^ (transaction changeFor: self) 
		working! !

LRSTMTest subclass: #LRSTMCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'lr 5/9/2007 10:04'!
testArrayLong
	| arr |
	arr := Array new: 10 withAll: 1.
	[ 3 to: 10 do: [ :each |
		arr at: each put: (arr at: each - 1) + (arr at: each - 2) ] ]
			atomic.
	3 to: 10 do: [ :each |
		self assert: (arr at: each) - (arr at: each - 1) = (arr at: each - 2) ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'lr 5/9/2007 10:04'!
testArrayShort
	| arr |
	arr := Array new: 10 withAll: 1.
	3 to: 10 do: [ :each |
		[ arr at: each put: (arr at: each - 1) + (arr at: each - 2) ]
			atomic ].
	3 to: 10 do: [ :each |
		self assert: (arr at: each) - (arr at: each - 1) = (arr at: each - 2) ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'lr 5/9/2007 10:04'!
testBagLong
	| bag |
	bag := Bag new.
	[ 1 to: 10 do: [ :each |
		bag add: each; add: each ] ]
			atomic.
	self assert: bag size = 20.
	1 to: 10 do: [ :each | 
		self assert: (bag occurrencesOf: each) = 2 ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'lr 5/10/2007 14:19'!
testBagShort
	| bag |
	bag := Bag new.
	1 to: 10 do: [ :each |
		[ bag add: each; add: each ]
			atomic ].
	self assert: bag size = 20.
	1 to: 10 do: [ :each | 
		self assert: (bag occurrencesOf: each) = 2 ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'lr 5/9/2007 10:03'!
testDictionaryLong
	| dict |
	dict := Dictionary new.
	[ 1 to: 10 do: [ :each | 
		dict at: each put: each ] ]
			atomic.
	self assert: dict size = 10.
	1 to: 10 do: [ :each | 
		self assert: (dict at: each) = each ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'lr 5/9/2007 10:03'!
testDictionaryShort
	| dict |
	dict := Dictionary new.
	1 to: 10 do: [ :each | 
		[ dict at: each put: each ]
			atomic ].
	self assert: dict size = 10.
	1 to: 10 do: [ :each | 
		self assert: (dict at: each) = each ]! !

!LRSTMCollectionTest methodsFor: 'testing-streams' stamp: 'lr 5/14/2007 15:44'!
testReadStream
	| stream |
	stream := (1 to: 10) asArray readStream.
	[ 1 to: 10 do: [ :each | self assert: stream next = each ] ]
		atomic! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'lr 5/9/2007 10:04'!
testSetLong
	| set |
	set := Set new.
	[ 1 to: 10 do: [ :each | 
		set add: each ] ] 
			atomic.
	self assert: set size = 10.
	1 to: 10 do: [ :each | 
		self assert: (set includes: each) ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'lr 5/9/2007 10:03'!
testSetShort
	| set |
	set := Set new.
	1 to: 10 do: [ :each |
		[ set add: each ]
			atomic ].
	self assert: set size = 10.
	1 to: 10 do: [ :each | 
		self assert: (set includes: each) ]! !

!LRSTMCollectionTest methodsFor: 'testing-streams' stamp: 'lr 5/14/2007 15:57'!
testStreamContents
	[ array := Array streamContents: [ :stream |
		1 to: 10 do: [ :each | 
			stream nextPut: each ] ] ]
		atomic.
	self assert: (1 to: 10) asArray = array! !

!LRSTMCollectionTest methodsFor: 'testing-streams' stamp: 'lr 5/14/2007 15:45'!
testWriteStream
	| stream |
	stream := (Array new: 10) writeStream.
	[ 1 to: 10 do: [ :each | stream nextPut: each ] ]
		atomic.
	self assert: (1 to: 10) asArray = stream contents! !

LRSTMTest subclass: #LRSTMCustomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMCustomTest methodsFor: 'actions' stamp: 'lr 2/26/2008 16:28'!
conflict
	<atomicDoNotTransform>

	self transaction 
		addChange: (LRSTMCustomChange 
			onApply: [ value := true ]
			onConflictTest: [ true ])! !

!LRSTMCustomTest methodsFor: 'actions' stamp: 'lr 2/26/2008 16:28'!
sideeffect
	<atomicDoNotTransform>

	self transaction 
		addChange: (LRSTMCustomChange onApply: [ value := true ])! !

!LRSTMCustomTest methodsFor: 'testing' stamp: 'lr 2/26/2008 16:22'!
testConflict
	self 
		should: [ [ self conflict ] atomic ]
		raise: LRSTMConflict.
	self assert: value isNil! !

!LRSTMCustomTest methodsFor: 'testing' stamp: 'lr 2/26/2008 16:23'!
testSideeffect
	[ self sideeffect ] atomic.
	self assert: value! !

LRSTMTest subclass: #LRSTMNestedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:46'!
testAbortInner
	self assert: [ value := true. [ value := false. self abort: value ] atomic. value ] atomic.
	self assert: value! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:50'!
testAbortOuter
	self assert: [ [ value := true ] atomic. self abort: value ] atomic.
	self assert: value isNil! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 16:54'!
testEmpty
	[ [ ] atomic ] atomic! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:46'!
testKind
	self assert: [ self transaction ] atomic isNested not.
	self assert: [ [ self transaction ] atomic ] atomic isNested.
	self assert: [ [ [ self transaction ] atomic ] atomic ] atomic isNested.
	
	self assert: [ [ ] atomic. self transaction ] atomic isNested not.! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 16:54'!
testSimple
	[ [ value := true ] atomic ] atomic.
	self assert: value! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:24'!
testValueInner
	self assert: [ value := true. [ value ] atomic ] atomic.
	self assert: value! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:24'!
testValueOuter
	self assert: [ [ value := true ] atomic. value ] atomic.
	self assert: value! !

!LRSTMTest class methodsFor: 'initialization' stamp: 'lr 5/4/2007 14:37'!
initialize
	self environment at: #GlobalValue put: nil! !

!LRSTMTest class methodsFor: 'testing' stamp: 'lr 2/26/2008 16:27'!
isAbstract
	^ self name = #LRSTMTest! !

!LRSTMTest methodsFor: 'utilities' stamp: 'lr 2/26/2008 16:24'!
abort: anObject
	<atomicDoNotTransform>

	self transaction abort: anObject! !

!LRSTMTest methodsFor: 'utilities' stamp: 'lr 2/26/2008 16:24'!
checkpoint
	<atomicDoNotTransform>

	self transaction checkpoint! !

!LRSTMTest methodsFor: 'running' stamp: 'lr 2/26/2008 18:30'!
setUp
	value := nil.
	array := Array new: 1.
	Value := nil.
	GlobalValue := nil! !

!LRSTMTest methodsFor: 'running' stamp: 'lr 2/26/2008 18:30'!
tearDown
	Processor activeProcess currentTransaction: nil! !

!LRSTMTest methodsFor: 'utilities' stamp: 'lr 2/26/2008 16:24'!
transaction
	<atomicDoNotTransform>

	^ Processor activeProcess currentTransaction! !

!LRSTMTest methodsFor: 'accessing' stamp: 'lr 5/3/2007 15:59'!
value
	^ value! !

!LRSTMTest methodsFor: 'accessing' stamp: 'lr 6/8/2007 16:52'!
value: anObject
	value := anObject! !

TestCase subclass: #LRSTMUtilitiesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMUtilitiesTest methodsFor: 'testing' stamp: 'lr 5/10/2007 11:48'!
testAsAtomicSelector
	self assert: #string asAtomicSelector == #'__atomic__string'.
	self assert: #linesDo: asAtomicSelector == #'__atomic__linesDo:'.
	self assert: #indexOf:startingAt: asAtomicSelector == #'__atomic__indexOf:startingAt:'.
	self assert: #// asAtomicSelector == #'__atomic__//'! !

!LRSTMUtilitiesTest methodsFor: 'testing' stamp: 'lr 5/10/2007 11:48'!
testAsNormalSelector
	self assert: #'__atomic__string' asNormalSelector == #string.
	self assert: #'__atomic__linesDo:' asNormalSelector == #linesDo:.
	self assert: #'__atomic__indexOf:startingAt:' asNormalSelector == #indexOf:startingAt:.
	self assert: #'__atomic__//' asNormalSelector == #//! !

!LRSTMUtilitiesTest methodsFor: 'testing' stamp: 'lr 5/9/2007 10:29'!
testIsAtomicSelector
	self deny: #string isAtomicSelector.
	self deny: #linesDo: isAtomicSelector.
	self deny: #indexOf:startingAt: isAtomicSelector.
	self deny: #// isAtomicSelector.

	self assert: #'__atomic__string' isAtomicSelector.
	self assert: #'__atomic__linesDo:' isAtomicSelector.
	self assert: #'__atomic__indexOf:startingAt:' isAtomicSelector.
	self assert: #'__atomic__//:' isAtomicSelector! !

!LRSTMUtilitiesTest methodsFor: 'testing-symbol' stamp: 'lr 5/10/2007 11:59'!
testIsInfix
	self deny: #string isInfix.
	self deny: #'__atomic__string' isInfix.
	
	self deny: #linesDo: isInfix.
	self deny: #'__atomic__linesDo:' isInfix.
	
	self deny: #indexOf:startingAt: isInfix.
	self deny: #'__atomic__indexOf:startingAt:' isInfix.
	
	self assert: #// isInfix.
	self assert: #'__atomic__//' isInfix! !

!LRSTMUtilitiesTest methodsFor: 'testing-symbol' stamp: 'lr 5/10/2007 11:58'!
testIsKeyword
	self deny: #string isKeyword.
	self deny: #'__atomic__string' isKeyword.
	
	self assert: #linesDo: isKeyword.
	self assert: #'__atomic__linesDo:' isKeyword.
	
	self assert: #indexOf:startingAt: isKeyword.
	self assert: #'__atomic__indexOf:startingAt:' isKeyword.
	
	self deny: #// isKeyword.
	self deny: #'__atomic__//' isKeyword! !

!LRSTMUtilitiesTest methodsFor: 'testing-symbol' stamp: 'lr 5/10/2007 11:56'!
testIsUnary
	self assert: #string isUnary.
	self assert: #'__atomic__string' isUnary.
	
	self deny: #linesDo: isUnary.
	self deny: #'__atomic__linesDo:' isUnary.
	
	self deny: #indexOf:startingAt: isUnary.
	self deny: #'__atomic__indexOf:startingAt:' isUnary.
	
	self deny: #// isUnary.
	self deny: #'__atomic__//' isUnary! !

!LRSTMUtilitiesTest methodsFor: 'testing-symbol' stamp: 'lr 5/10/2007 11:55'!
testNumArgs
	self assert: #string numArgs = 0.
	self assert: #'__atomic__string' numArgs = 0.
	
	self assert: #linesDo: numArgs = 1.
	self assert: #'__atomic__linesDo:' numArgs = 1.
	
	self assert: #indexOf:startingAt: numArgs = 2.
	self assert: #'__atomic__indexOf:startingAt:' numArgs = 2.
	
	self assert: #// numArgs = 1.
	self assert: #'__atomic__//' numArgs = 1! !

!SequenceableCollection methodsFor: '*LRSTM' stamp: 'lr 6/7/2007 15:14'!
atomicReplaceFrom: start to: stop with: replacement startingAt: repStart
	| index repOff |
	repOff := repStart - start.
	index := start - 1.
	[ (index := index + 1) <= stop ]
		whileTrue: [ self at: index put: (replacement at: repOff + index) ]! !

!ByteArray methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 15:15'!
replaceFrom: start to: stop with: replacement startingAt: repStart
	"Primitive. This destructively replaces elements from start to stop in the receiver starting at index, repStart, in the collection, replacement. Answer the receiver. Range checks are performed in the primitive only. Optional. See Object documentation whatIsAPrimitive."
	
	<primitive: 105>
	<atomic: #atomicReplaceFrom:to:with:startingAt:>
	super replaceFrom: start to: stop with: replacement startingAt: repStart! !

!TraitBehavior methodsFor: '*LRSTM' stamp: 'lr 5/11/2007 15:58'!
flushAtomic
	| changed copy |
	changed := false.
	copy := self methodDictionary copy.
	self methodDictionary keysDo: [ :each |
		each isAtomicSelector ifTrue: [ 
			copy removeDangerouslyKey: each ifAbsent: [].
			changed := true ] ].
	changed ifTrue: [ self methodDictionary become: copy ]! !

!TraitBehavior methodsFor: '*LRSTM-override' stamp: 'lr 5/9/2007 11:05'!
selectorsAndMethodsDo: aBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysAndValuesDo: [ :selector :method |
		selector isAtomicSelector 
			ifFalse: [ aBlock value: selector value: method ] ]! !

Object subclass: #Foo
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!Foo methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/1/2011 19:00'!
atomicBlock
	[ [ a := 42.
		 a asString ] atomic. ] value.
	^ a! !

!Foo methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/3/2011 18:59'!
whileTrueProblem
	| i x | 
	i := 1. x := 0.
	[ [ x := x + i. i := i + 1. i <= 10 ] whileTrue ] atomic.
	self assert: x = 55.! !

Object subclass: #LRSTMBenchmark
	instanceVariableNames: ''
	classVariableNames: 'Value'
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

LRSTMBenchmark class
	instanceVariableNames: 'value mutex doneCount'!

LRSTMBenchmark class
	instanceVariableNames: 'value mutex doneCount'!

!LRSTMBenchmark class methodsFor: 'utilities' stamp: 'lr 5/30/2007 16:10'!
benchmark: aOriginalBlock reference: aReferenceBlock label: aString
	"Assert that aFastBlock is executed faster than aSlow block. The two blocks should be relatively fast and have no side effects, as they are executed multiple times."
	
	| originalTime referenceTime |
	originalTime := aOriginalBlock timeToRun.
	referenceTime := aReferenceBlock timeToRun.
	Transcript 
		show: aString; tab;
		show: ((referenceTime / 1000.0) roundTo: 0.01); tab;
		show: ((originalTime / 1000.0) roundTo: 0.01); tab;
		show: ((originalTime / referenceTime) asFloat roundTo: 0.01); cr! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:16'!
benchmarkActivation
	"self benchmarkActivation"
	
	self 
		benchmark: [ 10000000 timesRepeat: [ [ ] atomic ] ]
		reference: [ 10000000 timesRepeat: [ [ ] value ] ]
		label: 'Activation'! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:17'!
benchmarkBinding
	"self benchmarkBinding"

	self
		benchmark: [ [ 10000000 timesRepeat: [ Value ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ Value ] ] value ]
		label: 'Binding Read'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ Value := nil ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ Value := nil ] ] value ]
		label: 'Binding Write'.! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:17'!
benchmarkInstance
	"self benchmarkInstance"
	
	self 
		benchmark: [ [ 10000000 timesRepeat: [ value ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ value ] ] value ]
		label: 'Instance Read'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ value := nil ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ value := nil ] ] value ]
		label: 'Instance Write'! !

!LRSTMBenchmark class methodsFor: 'btree' stamp: 'lr 5/31/2007 17:11'!
benchmarkParallel
	"self benchmarkParallel"

	| semaphore data doneCount repeatCount time |
	semaphore := Semaphore forMutualExclusion.
	
	1 to: 70 do: [ :processCount |
		Smalltalk garbageCollect.
		
		data := BTree new.
		doneCount := 0.
		repeatCount := 500.
	
		processCount timesRepeat: [
			[ repeatCount timesRepeat: [ self twoAtomicUpdates: data ].
			  semaphore critical: [ doneCount := doneCount + 1 ] ]
				forkAt: Processor activeProcess priority ].
		time := [
			[ doneCount < processCount ]
				whileTrue: [ Processor yield ] ]
			timeToRun.

		Transcript show: processCount; tab; show: time; cr ]! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:17'!
benchmarkSend
	"self benchmarkSend"
	
	self
		benchmark: [ [ 10000000 timesRepeat: [ nil flag: #zork ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ nil flag: #zork ] ] value ]
		label: 'Message invokation'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ nil flag: #zork ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ 1 + 2 ] ] value ]
		label: 'Message invokation (fast)'! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:18'!
benchmarkVariable
	"self benchmarkVariable"

	self 
		benchmark: [ [ 10000000 timesRepeat: [ #( nil ) at: 1 ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ #( nil ) at: 1 ] ] value ]
		label: 'Variable Read'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ #( nil ) at: 1 put: nil ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ #( nil ) at: 1 put: nil ] ] value ]
		label: 'Variable Write'! !

!LRSTMBenchmark class methodsFor: 'btree' stamp: 'lr 5/31/2007 17:11'!
twoAtomicUpdates: aDictionary
	[ [ aDictionary 
		at: SmallInteger maxVal atRandom put: 0;
		at: SmallInteger maxVal atRandom put: 0 ]
			atomic ]
		on: LRSTMConflict
		do: [ self twoAtomicUpdates: aDictionary ]! !

!LRSTMBenchmark class methodsFor: 'btree' stamp: 'lr 6/1/2007 11:01'!
twoMutexUpdates: aDictionary
	mutex critical: [
		aDictionary
			at: SmallInteger maxVal atRandom put: 0;
			at: SmallInteger maxVal atRandom put: 0 ]! !

Object subclass: #LRSTMChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Model'!

!LRSTMChange methodsFor: 'actions' stamp: 'lr 6/8/2007 16:59'!
apply
	self subclassResponsibility! !

!LRSTMChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasChanged
	^ true! !

!LRSTMChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasConflict
	^ false! !

LRSTMChange subclass: #LRSTMCustomChange
	instanceVariableNames: 'applyBlock conflictTestBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Model'!

!LRSTMCustomChange class methodsFor: 'instance-creation' stamp: 'lr 2/26/2008 16:15'!
onApply: anApplyBlock
	^ self onApply: anApplyBlock onConflictTest: [ false ]! !

!LRSTMCustomChange class methodsFor: 'instance-creation' stamp: 'lr 6/8/2007 17:03'!
onApply: anApplyBlock onConflictTest: aConflictTestBlock
	^ self basicNew initializeApply: anApplyBlock conflictTest: aConflictTestBlock! !

!LRSTMCustomChange methodsFor: 'actions' stamp: 'lr 2/26/2008 16:26'!
apply
	applyBlock value! !

!LRSTMCustomChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:28'!
hasConflict
	^ conflictTestBlock value! !

!LRSTMCustomChange methodsFor: 'initialization' stamp: 'lr 6/8/2007 17:04'!
initializeApply: anApplyBlock conflictTest: aConflictTestBlock	
	applyBlock := anApplyBlock.
	conflictTestBlock := aConflictTestBlock! !

LRSTMChange subclass: #LRSTMObjectChange
	instanceVariableNames: 'original previous working'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Model'!

!LRSTMObjectChange class methodsFor: 'instance-creation' stamp: 'lr 6/8/2007 16:59'!
on: anObject
	^ self basicNew initializeOn: anObject! !

!LRSTMObjectChange methodsFor: 'actions' stamp: 'lr 6/8/2007 16:59'!
apply
	original restoreSnapshot: working! !

!LRSTMObjectChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasChanged
	^ (working isIdenticalToSnapshot: previous) not! !

!LRSTMObjectChange methodsFor: 'testing' stamp: 'lr 6/8/2007 17:00'!
hasConflict
	^ (original isIdenticalToSnapshot: previous) not! !

!LRSTMObjectChange methodsFor: 'initialization' stamp: 'lr 6/8/2007 16:59'!
initializeOn: anObject
	original := anObject.
	working := original snapshotCopy.
	previous := working snapshotCopy! !

!LRSTMObjectChange methodsFor: 'accessing' stamp: 'lr 6/8/2007 17:00'!
original
	^ original! !

!LRSTMObjectChange methodsFor: 'accessing' stamp: 'lr 6/8/2007 17:00'!
previous
	^ previous! !

!LRSTMObjectChange methodsFor: 'printing' stamp: 'lr 6/8/2007 17:01'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' ['; print: self original; nextPut: $]! !

!LRSTMObjectChange methodsFor: 'accessing' stamp: 'lr 6/8/2007 17:00'!
working
	^ working! !

Object subclass: #LRSTMHello
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMHello class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/29/2011 01:12'!
example
	|  p1 p2 hello |
	hello := self new.
	
	"Since this main thread is not running inside the OPSTMDomain, which would be easy, too,
	 but is not happening here, we need to manually move the object into the domain."
	
	hello a: 'main'; b: 'main'.
	
	p1 := [
		1 halt.
		[	hello a: 'p1'.
			Processor yield.
			hello b: 'p1'.] atomic
	] fork.

	p2 := [
		[	| b |
			b := hello b.
			Processor yield.
			hello b: 'p2'.] atomic
	] fork.! !

!LRSTMHello methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/29/2011 01:11'!
a
	^ a asString! !

!LRSTMHello methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/29/2011 01:12'!
a: obj
	a := obj asString! !

!LRSTMHello methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/29/2011 01:12'!
b
	Transcript log: 'Read b: ', b asString.
	^ b asString! !

!LRSTMHello methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/29/2011 01:12'!
b: obj
	Transcript log: 'Write b: ', obj asString.
	b := obj asString! !

Object subclass: #LRSTMTransaction
	instanceVariableNames: 'parent context changes objectChanges'
	classVariableNames: ''
	poolDictionaries: 'ContextPart'
	category: 'LRSTM-Model'!

!LRSTMTransaction methodsFor: 'private' stamp: 'lr 2/26/2008 18:45'!
abort
	"Abort a transaction."
	
	<atomicDoNotTransform>
	parent := context := changes := objectChanges := nil! !

!LRSTMTransaction methodsFor: 'public' stamp: 'lr 2/26/2008 18:32'!
abort: aValue
	"Abort a transaction."
	
	<atomicDoNotTransform>
	Processor activeProcess currentTransaction: parent.
	thisContext swapSender: context.
	self abort.
	^ aValue! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'lr 2/26/2008 17:07'!
addChange: aChange
	<atomicDoNotTransform>
	^ changes add: aChange! !

!LRSTMTransaction methodsFor: 'private' stamp: 'lr 2/26/2008 18:42'!
begin
	"Start a transaction. If this is a nested transaction copy the parent changes into our own context."
	
	<atomicDoNotTransform>
	changes := OrderedCollection new.
	objectChanges := IdentityDictionary new.
	self isNested ifTrue: [
		parent objectChanges
			keysAndValuesDo: [ :key :value | objectChanges at: key put: value copy ] ]! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'lr 2/26/2008 17:07'!
changeFor: anObject
	<atomicDoNotTransform>
	^ objectChanges at: anObject ifAbsentPut: [ self addChange: (LRSTMObjectChange on: anObject) ]! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'lr 2/26/2008 17:07'!
changes
	"Answer an ordered collection of unique changes."

	<atomicDoNotTransform>
	^ changes! !

!LRSTMTransaction methodsFor: 'public' stamp: 'lr 2/26/2008 16:59'!
checkpoint
	"Checkpoint a transaction."

	<atomicDoNotTransform>
	self commit; begin! !

!LRSTMTransaction methodsFor: 'private' stamp: 'lr 6/7/2007 16:47'!
commit
	"Commit a transaction."

	<atomicDoNotTransform>
	self commitIfConflict: [ self signalConflict ]! !

!LRSTMTransaction methodsFor: 'private' stamp: 'lr 2/26/2008 18:46'!
commitIfConflict: aBlock
	"Commit a transaction atomically."
	
	<atomicDoNotTransform>
	[	changes do: [ :each |
			each hasConflict
				ifTrue: [ ^ aBlock value ] ].
		self isNested 
			ifTrue: [
				objectChanges keysAndValuesDo: [ :key :value |
					(parent objectChanges includesKey: key)
						ifFalse: [ parent addChange: value ].
					parent objectChanges at: key put: value ] ]
			ifFalse: [ 	
				changes do: [ :each |
					each hasChanged
						ifTrue: [ each apply ] ] ] ]
		valueUnpreemptively! !

!LRSTMTransaction methodsFor: 'public' stamp: 'lr 2/26/2008 16:59'!
do: aBlock
	"Start a transaction with aBlock."

	<atomicDoNotTransform>		
	^ self do: aBlock ifConflict: [ self signalConflict ]! !

!LRSTMTransaction methodsFor: 'public' stamp: 'lr 2/26/2008 18:38'!
do: aBlock ifConflict: aConflictBlock
	"Evaluate aBLock within a new transaction, unless we are already in an existing transactional context. Evaluate aConflictBlock if the transaction conflicts with concurrent edits."

	<atomicDoNotTransform>
	| result |
	parent := Processor activeProcess currentTransaction.
	Processor activeProcess currentTransaction: self.
	context := thisContext sender.
	self begin.
	[ result := aBlock 
		ensure: [ Processor activeProcess currentTransaction: parent ] ]
		ifCurtailed: [ self abort ].
	self commitIfConflict: aConflictBlock.
	^ result! !

!LRSTMTransaction methodsFor: 'testing' stamp: 'lr 2/26/2008 18:42'!
isNested
	<atomicDoNotTransform>
	^ parent notNil! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'lr 2/26/2008 18:44'!
objectChanges
	<atomicDoNotTransform>
	^ objectChanges! !

!LRSTMTransaction methodsFor: 'accessing' stamp: 'lr 2/26/2008 18:31'!
parent
	<atomicDoNotTransform>
	^ parent! !

!LRSTMTransaction methodsFor: 'public' stamp: 'lr 6/7/2007 12:10'!
retry: aBlock
	"Unconditionally retry to evaluate aBlock until there are no conflict."

	<atomicDoNotTransform>
	^ self do: aBlock ifConflict: [ self retry: aBlock ]! !

!LRSTMTransaction methodsFor: 'private' stamp: 'lr 2/26/2008 18:09'!
signalConflict
	<atomicDoNotTransform>
	^ LRSTMConflict new transaction: self; signal! !

!Object methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 13:32'!
at: index 
	"Primitive. Assumes receiver is indexable. Answer the value of an 
	indexable element in the receiver. Fail if the argument index is not an 
	Integer or is out of bounds. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 60>
	<atomic: #atomicAt:>
	index isInteger ifTrue:
		[self class isVariable
			ifTrue: [self errorSubscriptBounds: index]
			ifFalse: [self errorNotIndexable]].
	index isNumber
		ifTrue: [^self at: index asInteger]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 13:32'!
at: index put: value
	"Primitive. Assumes receiver is indexable. Store the argument value in 
	the indexable element of the receiver indicated by index. Fail if the 
	index is not an Integer or is out of bounds. Or fail if the value is not of 
	the right type for this kind of collection. Answer the value that was 
	stored. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 61>
	<atomic: #atomicAt:put:>
	index isInteger ifTrue:
		[self class isVariable
			ifTrue: [(index >= 1 and: [index <= self size])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]]
			ifFalse: [self errorNotIndexable]].
	index isNumber
		ifTrue: [^self at: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: '*LRSTM-atomic' stamp: 'lr 6/7/2007 12:12'!
atomicAt: anInteger
	<atomicDoNotTransform>
	^ self workingCopy at: anInteger! !

!Object methodsFor: '*LRSTM-atomic' stamp: 'lr 6/7/2007 12:12'!
atomicAt: anInteger put: anObject
	<atomicDoNotTransform>
	^ self workingCopy at: anInteger put: anObject! !

!Object methodsFor: '*LRSTM-atomic' stamp: 'lr 6/7/2007 13:39'!
atomicBasicAt: anInteger
	<atomicDoNotTransform>
	^ self workingCopy basicAt: anInteger! !

!Object methodsFor: '*LRSTM-atomic' stamp: 'lr 6/7/2007 13:39'!
atomicBasicAt: anInteger put: anObject
	<atomicDoNotTransform>
	^ self workingCopy basicAt: anInteger put: anObject! !

!Object methodsFor: '*LRSTM-atomic' stamp: 'lr 6/7/2007 12:12'!
atomicInstVarAt: anInteger
	<atomicDoNotTransform>
	^ self workingCopy instVarAt: anInteger! !

!Object methodsFor: '*LRSTM-atomic' stamp: 'lr 6/7/2007 12:12'!
atomicInstVarAt: anInteger put: anObject
	<atomicDoNotTransform>
	^ self workingCopy instVarAt: anInteger put: anObject! !

!Object methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 13:33'!
basicAt: index
	"Primitive. Assumes receiver is indexable. Answer the value of an 
	indexable element in the receiver. Fail if the argument index is not an 
	Integer or is out of bounds. Essential. Do not override in a subclass. See 
	Object documentation whatIsAPrimitive."

	<primitive: 60>
	<atomic: #atomicBasicAt:>
	index isInteger ifTrue: [self errorSubscriptBounds: index].
	index isNumber
		ifTrue: [^self basicAt: index asInteger]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: '*LRSTM-override' stamp: 'lr 6/7/2007 13:33'!
basicAt: index put: value
	"Primitive. Assumes receiver is indexable. Store the second argument 
	value in the indexable element of the receiver indicated by index. Fail 
	if the index is not an Integer or is out of bounds. Or fail if the value is 
	not of the right type for this kind of collection. Answer the value that 
	was stored. Essential. Do not override in a subclass. See Object 
	documentation whatIsAPrimitive."

	<primitive: 61>
	<atomic: #atomicBasicAt:put:>
	index isInteger
		ifTrue: [(index >= 1 and: [index <= self size])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]].
	index isNumber
		ifTrue: [^self basicAt: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]! !

!Object methodsFor: '*LRSTM-override' stamp: 'StefanMarr 11/28/2011 23:00'!
doesNotUnderstand: aMessage 
	 "Handle the fact that there was an attempt to send the given message to the receiver but the receiver does not understand this message (typically sent from the machine when a message is sent to the receiver and no method is defined for that selector)."
	"Testing: (3 activeProcess)"
	"fixed suggested by Eliot miranda to make sure 
	
	[Object new blah + 1]
		on: MessageNotUnderstood
		do: [:e | e resume: 1] does not loop indefinitively"
		
	| exception resumeValue |
	
	<atomicDoNotTransform>	
	aMessage selector isAtomicSelector
		ifTrue: [
			LRSTMCompiler atomicMethod: aMessage missing: self.
			"And try again."
			aMessage sendTo: self.]
		ifFalse: [
			(exception := MessageNotUnderstood new)
				message: aMessage;
				receiver: self.
			resumeValue := exception signal.
			^exception reachedDefaultHandler
				ifTrue: [aMessage sentTo: self]
				ifFalse: [resumeValue]]! !

!Object methodsFor: '*LRSTM-override' stamp: 'lr 6/8/2007 16:45'!
halt
	"This is the typical message to use for inserting breakpoints during 
	debugging. It behaves like halt:, but does not call on halt: in order to 
	avoid putting this message on the stack. Halt is especially useful when 
	the breakpoint message is an arbitrary one."

	<atomicDoNotTransform>
	Halt signal! !

!Object methodsFor: '*LRSTM-override' stamp: 'StefanMarr 11/28/2011 23:01'!
instVarAt: index 
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 73>
	<atomic: #atomicInstVarAt:>
	"Access beyond fixed variables."
	^self basicAt: index - self class instSize		! !

!Object methodsFor: '*LRSTM-override' stamp: 'StefanMarr 11/28/2011 23:01'!
instVarAt: anInteger put: anObject 
	"Primitive. Store a value into a fixed variable in the receiver. The 
	numbering of the variables corresponds to the named instance variables. 
	Fail if the index is not an Integer or is not the index of a fixed variable. 
	Answer the value stored as the result. Using this message violates the 
	principle that each object has sovereign control over the storing of 
	values into its instance variables. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 74>
	<atomic: #atomicInstVarAt:put:>
	"Access beyond fixed fields"
	^self basicAt: anInteger - self class instSize put: anObject! !

!Object methodsFor: '*LRSTM' stamp: 'lr 6/7/2007 15:05'!
isIdenticalToSnapshot: anObject
	1 to: self class instSize do: [ :index | 
		(self instVarAt: index) == (anObject instVarAt: index)
			ifFalse: [ ^ false ] ].
	self class isVariable ifTrue: [
		1 to: self size do: [ :index | 
			(self at: index) == (anObject at: index)
				ifFalse: [ ^ false ] ] ].
	^ true! !

!Object methodsFor: '*LRSTM' stamp: 'lr 6/7/2007 13:47'!
restoreSnapshot: anObject
	<primitive: 168>
	self primitiveFailed! !

!Object methodsFor: '*LRSTM' stamp: 'lr 6/7/2007 13:48'!
snapshotCopy
	<primitive: 148>
	self primitiveFailed! !

!Object methodsFor: '*LRSTM' stamp: 'lr 5/30/2007 12:11'!
workingCopy
	"Answer a working copy to be used within the context of the current transaction."
	
	| transaction |
	transaction := Processor activeProcess currentTransaction
		ifNil: [ self error: 'No active transaction' ].
	^ (transaction changeFor: self) working! !

!ParseNode methodsFor: '*LRSTM-testing' stamp: 'StefanMarr 11/30/2011 14:56'!
isAtomicSendToBlock

	^false! !

!ParseNode methodsFor: '*LRSTM-testing' stamp: 'StefanMarr 11/30/2011 19:29'!
isSelectorNode
	^ false! !
LRSTMTest initialize!
LRSTMCompiler initialize!
